'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasArgs = hasArgs;
exports.hasNoArgs = hasNoArgs;
exports.isStringArg = isStringArg;
exports.isNumArg = isNumArg;
exports.isDef = isDef;
exports.dataViewToString = dataViewToString;


/*global DataView*/

// copy from model.util to make flow happy
// flow predicate %check functions
function hasArgs(value) {
  return arguments.length != 0 && typeof value != 'undefined';
}
function hasNoArgs(value) {
  return arguments.length == 0 || typeof value === 'undefined';
}
function isStringArg(value) {
  return arguments.length != 0 && typeof value === 'string';
}
function isNumArg(value) {
  return typeof value === 'number';
}

function isDef(v) {
  return typeof v !== 'undefined' && v !== null;
}

function dataViewToString(dataView) {
  var out = "";
  for (var i = 0; i < dataView.byteLength; i++) {
    out += String.fromCharCode(dataView.getUint8(i));
  }
  return out;
}